Index: trunk/LMDZ.GENERIC/README
===================================================================
--- trunk/LMDZ.GENERIC/README	(revision 527)
+++ trunk/LMDZ.GENERIC/README	(revision 533)
@@ -583,7 +583,11 @@
 - corrects a small bug when no clouds are present in aeropacity
 
-
-
-
-
-
+== 16/02/2012 == JL + EM
+- Mesh area now present in 1d diag files.
+- Spectral Bandwidth included in the diagspec files
+- Correction of a initialzation bug on day_step and ecritphy in rcm1d
+
+
+
+
+
Index: trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specIR.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specIR.F	(revision 527)
+++ trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specIR.F	(revision 533)
@@ -2,5 +2,5 @@
 
       use radinc_h, only: L_NSPECTI
-      use radcommon_h, only: WNOI
+      use radcommon_h, only: WNOI,DWNI
 
       implicit none
@@ -107,11 +107,6 @@
 
       ierr = NF_DEF_DIM (nid, "index", length, idim_index)
-!      ierr = NF_DEF_DIM (nid, "rlonu", iip1, idim_rlonu)
       ierr = NF_DEF_DIM (nid, "latitude", jjp1, idim_rlatu)
       ierr = NF_DEF_DIM (nid, "longitude", iip1, idim_rlonv)
-!      ierr = NF_DEF_DIM (nid, "rlatv", jjm, idim_rlatv)
-!      ierr = NF_DEF_DIM (nid, "interlayer", (llm+1), idim_llmp1)
-      ierr = NF_DEF_DIM (nid, "altitude", llm, idim_llm)
-!      ierr = NF_DEF_DIM (nid, "subsurface_layers",nsoilmx,idim_nsoilmx)
       ierr = NF_DEF_DIM (nid, "IR Wavenumber",L_NSPECTI,idim_bandsIR)
 
@@ -140,20 +135,4 @@
 
 
-c$$$      ierr = NF_REDEF (nid)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_DEF_VAR (nid, "rlonu", NF_DOUBLE, 1, idim_rlonu,nvarid)
-c$$$#else
-c$$$      ierr = NF_DEF_VAR (nid, "rlonu", NF_FLOAT, 1, idim_rlonu,nvarid)
-c$$$#endif
-c$$$      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 21,
-c$$$     .                       "Longitudes at u nodes")
-c$$$      ierr = NF_ENDDEF(nid)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlonu/pi*180)
-c$$$#else
-c$$$      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlonu/pi*180)
-c$$$#endif
-
-c --------------------------
       ierr = NF_REDEF (nid)
 #ifdef NC_DOUBLE
@@ -189,97 +168,4 @@
 #endif
 c
-c --------------------------
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "altitude", NF_DOUBLE, 1, 
-     .       idim_llm,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "altitude", NF_FLOAT, 1, 
-     .       idim_llm,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"long_name",10,"pseudo-alt")
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,'units',2,"km")
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,'positive',2,"up")
-
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,pseudoalt)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,pseudoalt)
-#endif
-
-
-c$$$c --------------------------
-c$$$      ierr = NF_REDEF (nid)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_DEF_VAR (nid, "rlatv", NF_DOUBLE, 1, idim_rlatv,nvarid)
-c$$$#else
-c$$$      ierr = NF_DEF_VAR (nid, "rlatv", NF_FLOAT, 1, idim_rlatv,nvarid)
-c$$$#endif
-c$$$      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 20,
-c$$$     .                       "Latitudes at v nodes")
-c$$$      ierr = NF_ENDDEF(nid)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlatv/pi*180)
-c$$$#else
-c$$$      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlatv/pi*180)
-c$$$#endif
-
-
-c$$$c --------------------------
-c$$$c  Vertical levels
-c$$$      call def_var(nid,"aps","hybrid pressure at midlayers ","Pa",
-c$$$     .            1,idim_llm,nvarid,ierr)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,aps)
-c$$$#else
-c$$$      ierr = NF_PUT_VAR_REAL (nid,nvarid,aps)
-c$$$#endif
-c$$$
-c$$$      call def_var(nid,"bps","hybrid sigma at midlayers"," ",
-c$$$     .            1,idim_llm,nvarid,ierr)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,bps)
-c$$$#else
-c$$$      ierr = NF_PUT_VAR_REAL (nid,nvarid,bps)
-c$$$#endif
-c$$$
-c$$$      call def_var(nid,"ap","hybrid pressure at interlayers","Pa",
-c$$$     .            1,idim_llmp1,nvarid,ierr)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,ap)
-c$$$#else
-c$$$      ierr = NF_PUT_VAR_REAL (nid,nvarid,ap)
-c$$$#endif
-c$$$
-c$$$      call def_var(nid,"bp","hybrid sigma at interlayers"," ",
-c$$$     .            1,idim_llmp1,nvarid,ierr)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,bp)
-c$$$#else
-c$$$      ierr = NF_PUT_VAR_REAL (nid,nvarid,bp)
-c$$$#endif
-
-c$$$!-------------------------------
-c$$$! (soil) depth variable mlayer() (known from comsoil.h)
-c$$$!-------------------------------
-c$$$      ierr=NF_REDEF (nid) ! Enter NetCDF (re-)define mode
-c$$$      ! define variable
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr=NF_DEF_VAR(nid,"soildepth",NF_DOUBLE,1,idim_nsoilmx,nvarid)
-c$$$#else
-c$$$      ierr=NF_DEF_VAR(nid,"soildepth",NF_FLOAT,1,idim_nsoilmx,nvarid)
-c$$$#endif
-c$$$      ierr=NF_PUT_ATT_TEXT (nid,nvarid,"long_name", 20,
-c$$$     .                        "Soil mid-layer depth")
-c$$$      ierr=NF_PUT_ATT_TEXT (nid,nvarid,"units",1,"m")
-c$$$      ierr=NF_PUT_ATT_TEXT (nid,nvarid,"positive",4,"down")
-c$$$      ierr=NF_ENDDEF(nid) ! Leave NetCDF define mode
-c$$$      ! write variable
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr=NF_PUT_VAR_DOUBLE (nid,nvarid,mlayer)
-c$$$#else
-c$$$      ierr=NF_PUT_VAR_REAL (nid,nvarid,mlayer)
-c$$$#endif
 
 !-------------------------------
@@ -307,45 +193,32 @@
 #endif
 
+!-------------------------------
+! Width of bands in the IR
+!-------------------------------
+
+      ierr=NF_REDEF (nid) ! Enter NetCDF (re-)define mode
+      ! define variable
+#ifdef NC_DOUBLE
+      ierr=NF_DEF_VAR(nid,"IR Bandwidth",NF_DOUBLE,1,
+     .				idim_bandsIR,nvarid)
+#else
+      ierr=NF_DEF_VAR(nid,"IR Bandwidth",NF_FLOAT,1,
+     .				idim_bandsIR,nvarid)
+#endif
+      ierr=NF_PUT_ATT_TEXT (nid,nvarid,"long_name", 25,
+     .                        "Bandwidth in the infrared")
+      ierr=NF_PUT_ATT_TEXT (nid,nvarid,"units",5,"cm^-1")
+      ierr=NF_ENDDEF(nid) ! Leave NetCDF define mode
+      ! write variable
+#ifdef NC_DOUBLE
+      ierr=NF_PUT_VAR_DOUBLE (nid,nvarid,dble(DWNI))
+#else
+      ierr=NF_PUT_VAR_REAL (nid,nvarid,real(DWNI))
+#endif
 c
 c --------------------------
 c  Mesh area and conversion coefficients cov. <-> contra. <--> natural
 
-      id(1)=idim_rlonu
-      id(2)=idim_rlatu
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "cu", NF_DOUBLE, 2, id,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "cu", NF_FLOAT, 2, id,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 40,
-     .             "Conversion coefficients cov <--> natural")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,cu)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,cu)
-#endif
-c
-      id(1)=idim_rlonv
-      id(2)=idim_rlatv
-c
-c --------------------------
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "cv", NF_DOUBLE, 2, id,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "cv", NF_FLOAT, 2, id,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 40,
-     .             "Conversion coefficients cov <--> natural")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,cv)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,cv)
-#endif
-c
+
       id(1)=idim_rlonv
       id(2)=idim_rlatu
@@ -367,27 +240,4 @@
 #endif
 
-c  Surface geopotential
-      id(1)=idim_rlonv
-      id(2)=idim_rlatu
-
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "phisinit", NF_DOUBLE, 2, id,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "phisinit", NF_FLOAT, 2, id,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 27,
-     .                       "Geopotential at the surface")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,phis)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,phis)
-#endif,
-
-
-!      write(*,*)'iniwrite: iim,jjm,llm,idayref',iim,jjm,llm,idayref
-!      write(*,*)'iniwrite: rad,omeg,g,mugaz,rcp',rad,omeg,g,mugaz,rcp
-!      write(*,*)'iniwrite: daysec,dtphys',daysec,dtphys
 
       END
Index: trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specVI.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specVI.F	(revision 527)
+++ trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specVI.F	(revision 533)
@@ -2,5 +2,5 @@
 
       use radinc_h, only: L_NSPECTV
-      use radcommon_h, only: WNOV
+      use radcommon_h, only: WNOV,DWNV
 
       implicit none
@@ -107,11 +107,6 @@
 
       ierr = NF_DEF_DIM (nid, "index", length, idim_index)
-!      ierr = NF_DEF_DIM (nid, "rlonu", iip1, idim_rlonu)
       ierr = NF_DEF_DIM (nid, "latitude", jjp1, idim_rlatu)
       ierr = NF_DEF_DIM (nid, "longitude", iip1, idim_rlonv)
-!      ierr = NF_DEF_DIM (nid, "rlatv", jjm, idim_rlatv)
-!      ierr = NF_DEF_DIM (nid, "interlayer", (llm+1), idim_llmp1)
-      ierr = NF_DEF_DIM (nid, "altitude", llm, idim_llm)
-!      ierr = NF_DEF_DIM (nid, "subsurface_layers",nsoilmx,idim_nsoilmx)
       ierr = NF_DEF_DIM (nid, "VI Wavenumber",L_NSPECTV,idim_bandsVI)
 
@@ -139,21 +134,4 @@
 c  longitudes and latitudes
 
-
-c$$$      ierr = NF_REDEF (nid)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_DEF_VAR (nid, "rlonu", NF_DOUBLE, 1, idim_rlonu,nvarid)
-c$$$#else
-c$$$      ierr = NF_DEF_VAR (nid, "rlonu", NF_FLOAT, 1, idim_rlonu,nvarid)
-c$$$#endif
-c$$$      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 21,
-c$$$     .                       "Longitudes at u nodes")
-c$$$      ierr = NF_ENDDEF(nid)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlonu/pi*180)
-c$$$#else
-c$$$      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlonu/pi*180)
-c$$$#endif
-
-c --------------------------
       ierr = NF_REDEF (nid)
 #ifdef NC_DOUBLE
@@ -189,97 +167,4 @@
 #endif
 c
-c --------------------------
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "altitude", NF_DOUBLE, 1, 
-     .       idim_llm,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "altitude", NF_FLOAT, 1, 
-     .       idim_llm,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"long_name",10,"pseudo-alt")
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,'units',2,"km")
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,'positive',2,"up")
-
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,pseudoalt)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,pseudoalt)
-#endif
-
-
-c$$$c --------------------------
-c$$$      ierr = NF_REDEF (nid)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_DEF_VAR (nid, "rlatv", NF_DOUBLE, 1, idim_rlatv,nvarid)
-c$$$#else
-c$$$      ierr = NF_DEF_VAR (nid, "rlatv", NF_FLOAT, 1, idim_rlatv,nvarid)
-c$$$#endif
-c$$$      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 20,
-c$$$     .                       "Latitudes at v nodes")
-c$$$      ierr = NF_ENDDEF(nid)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlatv/pi*180)
-c$$$#else
-c$$$      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlatv/pi*180)
-c$$$#endif
-
-
-c$$$c --------------------------
-c$$$c  Vertical levels
-c$$$      call def_var(nid,"aps","hybrid pressure at midlayers ","Pa",
-c$$$     .            1,idim_llm,nvarid,ierr)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,aps)
-c$$$#else
-c$$$      ierr = NF_PUT_VAR_REAL (nid,nvarid,aps)
-c$$$#endif
-c$$$
-c$$$      call def_var(nid,"bps","hybrid sigma at midlayers"," ",
-c$$$     .            1,idim_llm,nvarid,ierr)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,bps)
-c$$$#else
-c$$$      ierr = NF_PUT_VAR_REAL (nid,nvarid,bps)
-c$$$#endif
-c$$$
-c$$$      call def_var(nid,"ap","hybrid pressure at interlayers","Pa",
-c$$$     .            1,idim_llmp1,nvarid,ierr)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,ap)
-c$$$#else
-c$$$      ierr = NF_PUT_VAR_REAL (nid,nvarid,ap)
-c$$$#endif
-c$$$
-c$$$      call def_var(nid,"bp","hybrid sigma at interlayers"," ",
-c$$$     .            1,idim_llmp1,nvarid,ierr)
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,bp)
-c$$$#else
-c$$$      ierr = NF_PUT_VAR_REAL (nid,nvarid,bp)
-c$$$#endif
-
-c$$$!-------------------------------
-c$$$! (soil) depth variable mlayer() (known from comsoil.h)
-c$$$!-------------------------------
-c$$$      ierr=NF_REDEF (nid) ! Enter NetCDF (re-)define mode
-c$$$      ! define variable
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr=NF_DEF_VAR(nid,"soildepth",NF_DOUBLE,1,idim_nsoilmx,nvarid)
-c$$$#else
-c$$$      ierr=NF_DEF_VAR(nid,"soildepth",NF_FLOAT,1,idim_nsoilmx,nvarid)
-c$$$#endif
-c$$$      ierr=NF_PUT_ATT_TEXT (nid,nvarid,"long_name", 20,
-c$$$     .                        "Soil mid-layer depth")
-c$$$      ierr=NF_PUT_ATT_TEXT (nid,nvarid,"units",1,"m")
-c$$$      ierr=NF_PUT_ATT_TEXT (nid,nvarid,"positive",4,"down")
-c$$$      ierr=NF_ENDDEF(nid) ! Leave NetCDF define mode
-c$$$      ! write variable
-c$$$#ifdef NC_DOUBLE
-c$$$      ierr=NF_PUT_VAR_DOUBLE (nid,nvarid,mlayer)
-c$$$#else
-c$$$      ierr=NF_PUT_VAR_REAL (nid,nvarid,mlayer)
-c$$$#endif
 
 !-------------------------------
@@ -308,48 +193,36 @@
 
 c
-c --------------------------
-c  Mesh area and conversion coefficients cov. <-> contra. <--> natural
-
-      id(1)=idim_rlonu
-      id(2)=idim_rlatu
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "cu", NF_DOUBLE, 2, id,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "cu", NF_FLOAT, 2, id,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 40,
-     .             "Conversion coefficients cov <--> natural")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,cu)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,cu)
-#endif
-c
-      id(1)=idim_rlonv
-      id(2)=idim_rlatv
-c
-c --------------------------
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "cv", NF_DOUBLE, 2, id,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "cv", NF_FLOAT, 2, id,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 40,
-     .             "Conversion coefficients cov <--> natural")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,cv)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,cv)
-#endif
-c
+!-------------------------------
+! Width of bands in the Visible
+!-------------------------------
+
+      ierr=NF_REDEF (nid) ! Enter NetCDF (re-)define mode
+      ! define variable
+#ifdef NC_DOUBLE
+      ierr=NF_DEF_VAR(nid,"VI Bandwidth",NF_DOUBLE,1,
+     .				idim_bandsVI,nvarid)
+#else
+      ierr=NF_DEF_VAR(nid,"VI Bandwidth",NF_FLOAT,1,
+     .				idim_bandsVI,nvarid)
+#endif
+      ierr=NF_PUT_ATT_TEXT (nid,nvarid,"long_name", 24,
+     .                        "Bandwidth in the visible")
+      ierr=NF_PUT_ATT_TEXT (nid,nvarid,"units",5,"cm^-1")
+      ierr=NF_ENDDEF(nid) ! Leave NetCDF define mode
+      ! write variable
+#ifdef NC_DOUBLE
+      ierr=NF_PUT_VAR_DOUBLE (nid,nvarid,dble(DWNV))
+#else
+      ierr=NF_PUT_VAR_REAL (nid,nvarid,real(DWNV))
+#endif
+c
+c --------------------------
+c   Mesh area
+c --------------------------
+
       id(1)=idim_rlonv
       id(2)=idim_rlatu
-c
-c --------------------------
+
+
       ierr = NF_REDEF (nid)
 #ifdef NC_DOUBLE
@@ -367,27 +240,5 @@
 #endif
 
-c  Surface geopotential
-      id(1)=idim_rlonv
-      id(2)=idim_rlatu
-
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "phisinit", NF_DOUBLE, 2, id,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "phisinit", NF_FLOAT, 2, id,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 27,
-     .                       "Geopotential at the surface")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,phis)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,phis)
-#endif,
-
-
-!      write(*,*)'iniwrite: iim,jjm,llm,idayref',iim,jjm,llm,idayref
-!      write(*,*)'iniwrite: rad,omeg,g,mugaz,rcp',rad,omeg,g,mugaz,rcp
-!      write(*,*)'iniwrite: daysec,dtphys',daysec,dtphys
+
 
       END
Index: trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F	(revision 527)
+++ trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F	(revision 533)
@@ -57,4 +57,5 @@
 #include "temps.h"
 #include "surfdat.h"
+#include "callkeys.h"
 
 ! Arguments on input:
@@ -102,9 +103,8 @@
 !Sortie des variables au rythme voulu
 
-      irythme = int(ecritphy) ! sortie au rythme de ecritphy
-!     irythme = iconser  ! sortie au rythme des variables de controle
+      irythme = int(ecritphy)*iradia ! sortie au rythme de ecritphy*iradia
+!EM+JL if the spetra need to be output more frequently, need to define a ecritSpec...
 !     irythme = iphysiq  ! sortie a tous les pas physique
-!     irythme = iecri*day_step ! sortie au rythme des fichiers histoires
-!     irythme = periodav*day_step ! sortie au rythme des fichiers histmoy
+
 
 !***************************************************************
Index: trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F	(revision 527)
+++ trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F	(revision 533)
@@ -57,4 +57,5 @@
 #include "temps.h"
 #include "surfdat.h"
+#include "callkeys.h"
 
 ! Arguments on input:
@@ -102,9 +103,7 @@
 !Sortie des variables au rythme voulu
 
-      irythme = int(ecritphy) ! sortie au rythme de ecritphy
-!     irythme = iconser  ! sortie au rythme des variables de controle
+      irythme = int(ecritphy)*iradia ! sortie au rythme de ecritphy
+!EM+JL if the spetra need to be output more frequently, need to define a ecritSpec...
 !     irythme = iphysiq  ! sortie a tous les pas physique
-!     irythme = iecri*day_step ! sortie au rythme des fichiers histoires
-!     irythme = periodav*day_step ! sortie au rythme des fichiers histmoy
 
 !***************************************************************